'use strict';

exports.__esModule = true;
exports.AddOptions = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ValueInput = require('./ValueInput');

var _ValueType = require('./ValueType');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var AddOptions = exports.AddOptions = function AddOptions(props) {
  var newNodeKey = props.newNodeKey;
  var updateNodeKey = props.updateNodeKey;
  var updateNodeValue = props.updateNodeValue;
  var addNode = props.addNode;
  var nodeType = props.nodeType;


  return _react2['default'].createElement(
    'div',
    null,
    _react2['default'].createElement('input', { onChange: updateNodeKey, value: newNodeKey }),
    ':',
    _react2['default'].createElement(_ValueInput.ValueInput, { nodeType: nodeType, updateNodeValue: updateNodeValue }),
    _react2['default'].createElement(_ValueType.ValueType, props),
    _react2['default'].createElement(
      'span',
      { onClick: addNode },
      'Add Node'
    )
  );
};

AddOptions.propTypes = {
  newNodeKey: _react.PropTypes.string,
  newNodeValue: _react.PropTypes.any,
  updateNodeKey: _react.PropTypes.func,
  updateNodeValue: _react.PropTypes.func,
  updateNodeType: _react.PropTypes.func,
  addNode: _react.PropTypes.func,
  nodeType: _react.PropTypes.any
};