'use strict';

exports.__esModule = true;
exports['default'] = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _dotObject = require('dot-object');

var DotObject = _interopRequireWildcard(_dotObject);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var JEHarness = function (_React$Component) {
  (0, _inherits3['default'])(JEHarness, _React$Component);

  function JEHarness(props) {
    (0, _classCallCheck3['default'])(this, JEHarness);

    var _this = (0, _possibleConstructorReturn3['default'])(this, _React$Component.call(this, props));

    _this.addNodeToObject = function (key, value, keyPath) {
      var path = [key].concat(keyPath).reverse();
      var dotPath = path.join('.');
      // assign new key as unique
      _this.setState(DotObject.copy('value', dotPath, { value: value }, _this.state));
    };

    _this.removeNodeFromObject = function (keyPath) {
      var path = [].concat(keyPath).reverse();
      var dotPath = path.join('.');
      var stateCopy = (0, _assign2['default'])({}, _this.state);
      DotObject.remove(dotPath, stateCopy);
      _this.setState(stateCopy);
    };

    _this.updateNodeValue = function (value, keyPath) {
      var path = [].concat(keyPath).reverse();
      var dotPath = path.join('.');
      _this.setState(DotObject.copy('value', dotPath, { value: value }, _this.state));
    };

    _this.updateNodeKey = function (newKey, keyPath) {
      var path = [].concat(keyPath).reverse();
      var dotPath = path.join('.');
      var value = DotObject.pick(dotPath, _this.state, true);
      path[path.length - 1] = newKey;
      var newDotPath = path.join('.');
      _this.setState(DotObject.copy('value', newDotPath, { value: value }, _this.state));
    };

    _this.state = {
      hunter: {
        name: 'hunter',
        age: 26,
        random: {
          nested: true,
          brother: 'Theo'
        },
        blank: {}
      }
    };
    return _this;
  }

  JEHarness.prototype.render = function render() {
    return _react2['default'].createElement(
      'div',
      null,
      _react2['default'].createElement(_index2['default'], {
        data: this.state,
        updateValue: this.updateNodeValue,
        updateNodeKey: this.updateNodeKey,
        removeNode: this.removeNodeFromObject,
        addNode: this.addNodeToObject
      })
    );
  };

  return JEHarness;
}(_react2['default'].Component);

exports['default'] = JEHarness;